<template>
    <div>
        <custom-card>
            <auto-datatable
                ref="dt"
                model="Country"
                :filters="[
                    {
                        label: $t('name'),
                        name: 'f-like-name',
                        type: 'text'
                    },
                    {
                        label: $t('status'),
                        name: 'f-status',
                        type: 'select', options: [
                            {value: '0', text: $t('disabled')},
                            {value: '1', text: $t('enabled')}
                        ]
                    }
                ]"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('actions'), name: 'actions'},
                    {label: $t('name'), name: 'name'},
                    {label: $t('currency'), name: 'currency_prefix'},
                    {label: $t('ext'), name: 'ext'},
                    {label: $t('conversion_rate'), name: 'conversion_rate'},
                    {label: $t('status'), name: 'status', column: 'status_explained'},
                ]"
            >
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>
                            <div class="flex justify-start space-x-1">
                                <edit-button
                                    @click="model = record"
                                />
                            </div>
                        </td>
                        <td>{{ record.name }}</td>
                        <td>{{ record.currency_prefix }}</td>
                        <td>{{ record.ext }}</td>
                        <td>{{ record.conversion_rate }}</td>
                        <td>{{ record.status_explained }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
        <panel-modal
            v-if="model"
            :has-footer="false"
            @close="model = null"
        >
            <template #body>
                <model-form
                    :form-model="model"
                    @update="updateRow"
                />
            </template>
        </panel-modal>
    </div>
</template>
<script setup>
import CustomCard from "~/components/custom-card.vue";
import PanelModal from "~/components/panel-modal.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import {ref} from "vue";
import EditButton from "~/components/button/edit-button.vue";
import ModelForm from '~/pages/main/other/country/model-form.vue';
import {useSettingStore} from "~/stores/setting.js";

const $settingStore = useSettingStore();
const model = ref(null);
const dt = ref();
const updateRow = async () => {
    model.value = null;

    await dt.value.loadData();
    await $settingStore.fetchSettings();
};
</script>
